<?php
/*
 * ARI Quiz Alta User Points Joomla! plugin
 *
 * @package		ARI Quiz Alta User Points
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2009 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemAriquizaltauserpoints extends JPlugin
{ 
	/*
	 * Constructor
	 */
	function plgSystemAriquizaltauserpoints(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	/*
	 * This method calls when user finishes quiz
	 * 
	 * @param    array  $params    Hash with the following keys
	 * 
	 * StatisticsInfoId
	 * UserName - user name
	 * QuizName - quiz name
	 * PassedScore - passed score
	 * MaxScore - max score
	 * UserScore - user score
	 * PercentScore - percent score
	 * _Passed - passed or not (1 or 0)
	 * StartDate - start date
	 * EndDate - end date
	 * SpentTime - spent time
	 * QuizId - quiz id
	 * 
	 * @access   public
	 */
	function onEndQuiz($quizParams)
	{
		if (!$this->_loadAUP()) 
			return ;

		$params = $this->params;
		$comment = $params->get('comment', '');
		$scoreRule = $params->get('scoreRule', 'always');
		$fixedScore = (bool)$params->get('fixedScore', false);
		$score = $fixedScore 
			? @floatval($params->get('score', 0))
			: $quizParams['UserScore'];
		
		if ($score == 0 ||
			($scoreRule == 'onsuccess' && !$quizParams['_Passed']))
		{
			return ;
		}

		AriKernel::import('SimpleTemplate.SimpleTemplate');
		
		if ($comment) $comment = AriSimpleTemplate::parse($comment, $quizParams);
		$earnScoreOneTime = (bool)$params->get('earnScoreOneTime', false);

		AltaUserPointsHelper::newpoints(
			'plgaup_ariquizuppoints', 
			'', 
			$earnScoreOneTime ? $quizParams['QuizId'] : '', 
			$comment,
			$score
		);
	}

	/*
	 * This method loads AlphaUserPoints framework
	 * 
	 * @access   private
	 */
	function _loadAUP()
	{
		$api_AUP = JPATH_SITE . '/components/com_altauserpoints/helper.php';
		
		if (!file_exists($api_AUP)) 
			return false;
		
		require_once $api_AUP;
		
		return true;
	}
}